# Do not modify this file!  It was generated by ‘nixos-generate-config’
# and may be overwritten by future invocations.  Please make changes
# to /etc/nixos/configuration.nix instead.
{ config, lib, pkgs, modulesPath, ... }:

{
  imports =
    [ (modulesPath + "/installer/scan/not-detected.nix")
    ];

  boot.initrd.availableKernelModules = [ 
    "nvme"
    "vfat"
    "xhci_pci"
    "usbhid"
    "usb_storage"
    "sd_mod"
    "sdhci_pci"
    "cryptd"
   ];

  # Wifi support
  boot.extraModulePackages = [ config.boot.kernelPackages.rtw89 ];
  hardware.firmware = [ pkgs.rtw89-firmware ];

  # For support of newer AMD GPUs, backlight and internal microphone
  boot.kernelPackages = lib.mkIf (lib.versionOlder pkgs.linux.version "5.13") pkgs.linuxPackages_latest;

  boot.initrd.kernelModules = [ "dm-snapshot" ];
  boot.kernelModules = [ "kvm-amd" ];
  boot.extraModulePackages = [ ];
  boot.supportedFilesystems = ["zfs"];

  boot.initrd.luks.devices."crypt" = 
    { device = "/dev/disk/by-partlabel/crypt";
      preLVM = true;
    };

  fileSystems."/" =
    { device = "rpool/root/nixos";
      fsType = "zfs";
    };

  fileSystems."/home" =
    { device = "rpool/home";
      fsType = "zfs";
    };

  fileSystems."/boot" =
    { device = "/dev/disk/by-partlabel/boot";
      fsType = "vfat";
    };

  swapDevices =
    [ { device = "/dev/partitions/swap"; }
    ];

}
